E-MailRelay

Public Member Functions | List of all members
GSmtp::AdminServerPeer Class Reference

A derivation of ServerPeer for the administration interface. More...

`#include <gadminserver.h>`

Inheritance diagram for GSmtp::AdminServerPeer:
[legend]
Collaboration diagram for GSmtp::AdminServerPeer:
[legend]

## Public Member Functions
| AdminServerPeer (GNet::EventStateUnbound, GNet::ServerPeerInfo &&, AdminServerImp &, const std::string &remote, const G::StringMap &info_commands, bool with_terminate)
| Constructor. More...
| ~AdminServerPeer () override
| Destructor. More...
bool | notifying () const
| Returns true if the remote user has asked for notifications. More...
void | notify (const std::string &s0, const std::string &s1, const std::string &s2, const std::string &s3)
| Called when something happens which the remote admin user might be interested in. More...
| AdminServerPeer (const AdminServerPeer &)=delete
| AdminServerPeer (AdminServerPeer &&)=delete
AdminServerPeer & | operator= (const AdminServerPeer &)=delete
AdminServerPeer & | operator= (AdminServerPeer &&)=delete
Public Member Functions inherited from GNet::ServerPeer
| ServerPeer (EventState, ServerPeerInfo &&, const LineBuffer::Config &)
| Constructor. More...
| ~ServerPeer () override
| Destructor. More...
bool | send (const std::string &data)
| Sends data down the socket to the peer. More...
bool | send (std::string_view data)
| Overload for string_view. More...
bool | send (const std::vector< std::string_view > &data, std::size_t offset=0U)
| Overload to send data using scatter-gather segments. More...
Address | localAddress () const override
| Returns the local address. More...
Address | peerAddress () const override
| Returns the peer address. More...
std::string | connectionState () const override
| Returns the connection state display string. More...
std::string | peerCertificate () const override
| Returns the peer's TLS certificate. More...
LineBufferState | lineBuffer () const
| Returns information about the state of the internal line-buffer. More...
void | setIdleTimeout (unsigned int seconds)
| Sets the idle timeout. More...
void | doOnDelete (const std::string &reason, bool done)
| Used by the GNet::Server class to call onDelete(). More...
| ServerPeer (const ServerPeer &)=delete
| ServerPeer (ServerPeer &&)=delete
ServerPeer & | operator= (const ServerPeer &)=delete
ServerPeer & | operator= (ServerPeer &&)=delete
bool | send (const char *, std::size_t offset)=delete
bool | send (const char *)=delete
bool | send (const std::string &, std::size_t offset)=delete
Public Member Functions inherited from GNet::Connection
virtual | ~Connection ()=default
| Destructor.
virtual Address | localAddress () const =0
| Returns the connection's local address. More...
virtual Address | peerAddress () const =0
| Returns the connection's peer address. More...
virtual std::string | connectionState () const =0
| Returns the connection state as a display string. More...
virtual std::string | peerCertificate () const =0
| Returns the peer's TLS certificate. More...
Public Member Functions inherited from GNet::ExceptionSource
virtual | ~ExceptionSource ()
| Destructor.
| ExceptionSource (const ExceptionSource &)=delete
| ExceptionSource (ExceptionSource &&)=delete
ExceptionSource & | operator= (const ExceptionSource &)=delete
ExceptionSource & | operator= (ExceptionSource &&)=delete

## Additional Inherited Members
Static Public Member Functions inherited from GNet::ServerPeer
static std::string | eventLoggingString (const Address &, const Config &)
| Assembles an event logging string for a new ServerPeer object. More...
Protected Member Functions inherited from GNet::ServerPeer
virtual void | onSendComplete ()=0
| Called after flow-control has been released and all residual data sent.
virtual bool | onReceive (const char *data, std::size_t size, std::size_t eolsize, std::size_t linesize, char c0)=0
| Called on receipt of a complete line of data. More...
virtual void | onDelete (const std::string &reason)=0
| Called just before the Server deletes this ServerPeer as the result of an exception (but not as a result of Server destruction). More...
void | secureAccept ()
| Waits for the peer to start a secure session. More...
bool | secureAcceptCapable () const
| Returns true if secureAccept() is usable. More...
StreamSocket & | socket ()
| Returns a reference to the client-server connection socket. More...
void | dropReadHandler ()
| Drops the socket() read handler. More...
void | addReadHandler ()
| Re-adds the socket() read handler. More...
void | expect (std::size_t)
| Modifies the line buffer state so that it delivers a chunk of non-line-delimited data. More...
void | finish ()
| Does a socket shutdown(). See also GNet::Client::finish(). More...
void | onData (const char *, std::size_t) override
| Override from GNet::SocketProtocolSink. More...

## Detailed Description

A derivation of ServerPeer for the administration interface.

The AdminServerPeer instantiates its own Smtp::Client in order to implement the "flush" command.

See also
  GSmtp::AdminServer

Definition at line 56 of file gadminserver.h.

## Constructor & Destructor Documentation

## ◆ AdminServerPeer()

GSmtp::AdminServerPeer::AdminServerPeer | ( | GNet::EventStateUnbound | esu,
|  | GNet::ServerPeerInfo && | peer_info,
|  | AdminServerImp & | server_imp,
|  | const std::string & | remote,
|  | const G::StringMap & | info_commands,
|  | bool | with_terminate
| ) |  |

Constructor.

Definition at line 81 of file gadminserver_enabled.cpp.

## ◆ ~AdminServerPeer()

GSmtp::AdminServerPeer::~AdminServerPeer | ( |  | ) |
| override

Destructor.

Definition at line 98 of file gadminserver_enabled.cpp.

## Member Function Documentation

## ◆ notify()

void GSmtp::AdminServerPeer::notify | ( | const std::string & | s0,
|  | const std::string & | s1,
|  | const std::string & | s2,
|  | const std::string & | s3
| ) |  |

Called when something happens which the remote admin user might be interested in.

Definition at line 318 of file gadminserver_enabled.cpp.

## ◆ notifying()

bool GSmtp::AdminServerPeer::notifying | ( |  | ) | const

Returns true if the remote user has asked for notifications.

Definition at line 382 of file gadminserver_enabled.cpp.

The documentation for this class was generated from the following files:

- /tmp/slackdce/slackrepo.HKsbdz/build_emailrelay/emailrelay-2.6/src/gsmtp/gadminserver.h
- /tmp/slackdce/slackrepo.HKsbdz/build_emailrelay/emailrelay-2.6/src/gsmtp/gadminserver_enabled.cpp